# dmp-rwd-version接口

## 版本管理接口

### 31001 创建版本信息

#### 接口

`http://localhost:8831/dmp-rwd-version/rwdedit/version/create`

#### 请求方式

POST请求

#### RequestHeader

| key          | value            |
| ------------ | ---------------- |
| Content-Type | application/json |

#### RequestParam(URL中的Path参数)

| 字段      | 是否必须 | 字段说明 |
| --------- | -------- | -------- |
| userId    | 是       | 用户id   |
| groupCode | 否       | 集团编码 |
| projectId | 否       | 项目id   |
| appId     | 否       | 应用id   |

#### 参数例子

```
{
  "version": "PG",
  "state": "major",
  "lastFlag": "专业",
  "lastVersion": "Testing",
  "showOrder":12,
  "confirmUser":"**",
  "confirmTime":"20210813000000",
  "publishUser":"***",
  "publishTime":"20210813000000",
  "finishTime":"20210813000000"
}
```

| 字段        | 是否必须 | 字段说明                                              |
| ----------- | -------- | ----------------------------------------------------- |
| version     | 是       | 版本号,全局唯一                                       |
| state       | 否       | 版本状态,0-已取消,1-待确认,2-待发布,3-发布中,4-已完成 |
| lastFlag    | 否       | 最新标识                                              |
| lastVersion | 否       | 上一版本号                                            |
| showOrder   | 否       | 显示顺序                                              |
| confirmUser | 否       | 确认人                                                |
| confirmTime | 否       | 确认时间                                              |
| publishUser | 否       | 发布人                                                |
| publishTime | 否       | 发布时间                                              |
| finishTime  | 否       | 完成时间                                              |

#### 成功例子

```
{
    "result": "success",
    "data": {
      "id": "dev_1",
      "version": "PG",
      "state": "major",
      "lastFlag": "专业",
      "lastVersion": "Testing",
      "showOrder":12,
      "confirmUser":"**",
      "confirmTime":"***",
      "publishUser":"***",
      "publishTime":"***",
      "finishTime":"***",
      "creationTime": "20210813000000",
      "creator": "wdl",
      "modifiedTime": "20210813000000",
      "modifier": "wdl",
      "valid": 1
    },
    "count": 26
}
```

| 字段         | 是否必有 | 字段说明                                              |
| ------------ | -------- | ----------------------------------------------------- |
| id           | 是       | 32位UUID                                              |
| version      | 是       | 版本号,全局唯一                                       |
| state        | 是       | 版本状态,0-已取消,1-待确认,2-待发布,3-发布中,4-已完成 |
| lastFlag     | 是       | 最新标识                                              |
| lastVersion  | 是       | 上一版本号                                            |
| showOrder    | 是       | 显示顺序                                              |
| confirmUser  | 否       | 确认人                                                |
| confirmTime  | 否       | 确认时间                                              |
| publishUser  | 否       | 发布人                                                |
| publishTime  | 否       | 发布时间                                              |
| finishTime   | 否       | 完成时间                                              |
| creationTime | 否       | 创建时间,格式为yyyyMMddHHmmss                         |
| creator      | 否       | 创建人账号id                                          |
| modifiedTime | 否       | 最后更新时间,格式为yyyyMMddHHmmss                     |
| modifier     | 否       | 最后更新账号id                                        |
| valid        | 否       | 有效状态,0-无效,1-有效                                |

#### 接口修改记录

| 操作时间              | 操作 | 操作内容 |
| --------------------- | ---- | -------- |
| 2021年8月17日09:45:09 | 新增 | 新增接口 |



### 31002 更新版本信息

#### 接口

`http://localhost:8831/dmp-rwd-version/rwdedit/version/update`

#### 请求方式

POST请求

#### RequestHeader

| key          | value            |
| ------------ | ---------------- |
| Content-Type | application/json |

#### RequestParam(URL中的Path参数)

| 字段      | 是否必须 | 字段说明 |
| --------- | -------- | -------- |
| userId    | 是       | 用户id   |
| groupCode | 否       | 集团编码 |
| projectId | 否       | 项目id   |
| appId     | 否       | 应用id   |

#### 参数例子

```
{
    "id": "dev_1",
    "version": "PG",
    "state": "major",
    "lastFlag": "专业",
    "lastVersion": "Testing",
    "showOrder":12,
    "confirmUser":"**",
    "confirmTime":"***",
    "publishUser":"***",
    "publishTime":"***",
    "finishTime":"***",
    "creationTime": "20210813000000",
    "creator": "wdl",
    "modifiedTime": "20210813000000",
    "modifier": "wdl",
    "valid": 1
}
```

| 字段         | 是否必须 | 字段说明                                              |
| ------------ | -------- | ----------------------------------------------------- |
| id           | 是       | 32位UUID                                              |
| version      | 是       | 版本号,全局唯一                                       |
| state        | 是       | 版本状态,0-已取消,1-待确认,2-待发布,3-发布中,4-已完成 |
| lastFlag     | 是       | 最新标识                                              |
| lastVersion  | 是       | 上一版本号                                            |
| showOrder    | 是       | 显示顺序                                              |
| confirmUser  | 否       | 确认人                                                |
| confirmTime  | 否       | 确认时间                                              |
| publishUser  | 否       | 发布人                                                |
| publishTime  | 否       | 发布时间                                              |
| finishTime   | 否       | 完成时间                                              |
| creationTime | 是       | 创建时间,格式为yyyyMMddHHmmss                         |
| creator      | 是       | 创建人账号id                                          |
| modifiedTime | 否       | 最后更新时间,格式为yyyyMMddHHmmss                     |
| modifier     | 否       | 最后更新账号id                                        |
| valid        | 是       | 有效状态,0-无效,1-有效                                |

#### 成功例子

```
{
    "result": "success",
    "data": {
      "id": "dev_1",
      "version": "PG",
      "state": "major",
      "lastFlag": "专业",
      "lastVersion": "Testing",
      "showOrder":12,
      "confirmUser":"**",
      "confirmTime":"***",
      "publishUser":"***",
      "publishTime":"***",
      "finishTime":"***",
      "creationTime": "20210813000000",
      "creator": "wdl",
      "modifiedTime": "20210813000000",
      "modifier": "wdl",
      "valid": 1
    },
    "count": 26
}
```

| 字段         | 是否必有 | 字段说明                                              |
| ------------ | -------- | ----------------------------------------------------- |
| id           | 是       | 32位UUID                                              |
| version      | 是       | 版本号,全局唯一                                       |
| state        | 是       | 版本状态,0-已取消,1-待确认,2-待发布,3-发布中,4-已完成 |
| lastFlag     | 是       | 最新标识,0-非最新,1-最新                              |
| lastVersion  | 是       | 上一版本号                                            |
| showOrder    | 是       | 显示顺序                                              |
| confirmUser  | 否       | 确认人                                                |
| confirmTime  | 否       | 确认时间                                              |
| publishUser  | 否       | 发布人                                                |
| publishTime  | 否       | 发布时间                                              |
| finishTime   | 否       | 完成时间                                              |
| creationTime | 否       | 创建时间,格式为yyyyMMddHHmmss                         |
| creator      | 否       | 创建人账号id                                          |
| modifiedTime | 否       | 最后更新时间,格式为yyyyMMddHHmmss                     |
| modifier     | 否       | 最后更新账号id                                        |
| valid        | 否       | 有效状态,0-无效,1-有效                                |

#### 接口修改记录

| 操作时间              | 操作 | 操作内容 |
| --------------------- | ---- | -------- |
| 2021年8月17日09:45:09 | 新增 | 新增接口 |



### 31003 删除版本信息

#### 接口

`http://localhost:8831/dmp-rwd-version/rwdedit/version/delete`

#### 请求方式

POST请求

#### RequestHeader

| key          | value            |
| ------------ | ---------------- |
| Content-Type | application/json |

#### RequestParam(URL中的Path参数)

| 字段      | 是否必须 | 字段说明 |
| --------- | -------- | -------- |
| userId    | 是       | 用户id   |
| groupCode | 否       | 集团编码 |
| projectId | 否       | 项目id   |
| appId     | 否       | 应用id   |

#### 参数例子

```
"***"
```

| 字段 | 是否必须 | 字段说明 |
| ---- | -------- | -------- |
| id   | 是       | 32位UUID |

#### 成功例子

```
{
    "result": "success"
}
```

#### 接口修改记录

| 操作时间              | 操作 | 操作内容 |
| --------------------- | ---- | -------- |
| 2021年8月17日09:50:14 | 新增 | 新增接口 |





